#include <stdio.h>
#include <allegro.h>
#include <string.h>

BEGIN_GFX_DRIVER_LIST
END_GFX_DRIVER_LIST
BEGIN_COLOR_DEPTH_LIST
 COLOR_DEPTH_8
 COLOR_DEPTH_24
END_COLOR_DEPTH_LIST
BEGIN_DIGI_DRIVER_LIST
END_DIGI_DRIVER_LIST
BEGIN_MIDI_DRIVER_LIST
END_MIDI_DRIVER_LIST
BEGIN_JOYSTICK_DRIVER_LIST
END_JOYSTICK_DRIVER_LIST

typedef struct
  {
   char *name;
   unsigned int x, y;
  } file_t;

file_t file[] =
 {
   { "cut0",       640, 480 },
   { "cut1",       640, 480 },
   { "cut2",       640, 480 },
   { "cut3",       640, 480 },
   { "cut4",       640, 480 },
   { "cut5",       640, 480 },
   { "f_bmg",      100,  50 },
   { "f_dma",       78, 109 },
   { "f_logo0",    640, 168 },
   { "f_logo1",    640, 168 },
   { "f_logo2",    640, 168 },
   { "f_logo3",    640, 168 },
   { "f_logo4",    640, 168 },
   { "f_logo5",    640, 168 },
   { "f_logo6",    640, 168 },
   { "f_logo7",    640, 168 },
   { "f_lower0",   640, 312 },
   { "f_lower1",   640, 312 },
   { "f_upper",    640, 168 },
   { "f_play1",    102, 141 },
   { "f_play2",    102, 141 },
   { "f_play3",    102, 141 },
   { "f_play4",    102, 141 },
   { "f_play5",    102, 141 },
   { "f_play6",    102, 141 },
   { "f_play7",    102, 141 },
   { "f_play8",    102, 141 },
   { "f_playn",    180,  50 },
   { "",             0,   0 }
 };

int raw2bmp( int k );
int bmp2raw( int k );

int main(int argc, char *argv[])
{
 char *name;
 int k;

 allegro_init();

 if (argc != 2)
   {
    printf( "Usage: %s file.{raw|bmp}\n", argv[0] );
    printf( "If you choose a *.raw file ou obtain a *.bmp\n"
            "If you choose a *.bmp file ou obtain a *.raw\n"
            "\n"
            "Choose now a file? " );
    name = (char*) malloc( 200 );
    scanf( "%s", name );
   }
  else
   {
    name = argv[1];
   }

 set_color_depth( 24 );

 for( k=0 ; file[k].x != 0 ; k++ )
   {
    if( strncmp( file[k].name, name, strlen(file[k].name) ) == 0 )
      {
            if( strcmp( name+strlen(name)-4, ".raw" ) == 0 ) return raw2bmp( k );
       else if( strcmp( name+strlen(name)-4, ".bmp" ) == 0 ) return bmp2raw( k );
       printf( "Input file aren't *.raw nor *.bmp\n" );
       return 1;
      }
   }

 printf( "Input file aren't a file in:\n" );
 for( k=0 ; file[k].x != 0 ; k++ )
   {
    printf( "\t%s", file[k].name );
   }
 printf( "\n" );

 return 1;
}
#ifndef DJGPP
END_OF_MAIN();
#endif

int raw2bmp( int k )
  {
   FILE *in;
   BITMAP *bmp;
   int i;
   char *buff;

   unsigned int w=file[k].x, h=file[k].y;
   char f_out[256], f_in[256];
   sprintf( f_out, "%s.bmp", file[k].name );
   sprintf( f_in , "%s.raw", file[k].name );
   printf( "%s --> %s\n", f_in, f_out );

   in = fopen( f_in, "rb" );
   if( in==NULL ) { printf( "No %s\n", f_in ); return 1; }

   bmp = create_bitmap_ex( 24, w, h );
   fread( &(bmp->line[0][0]), w*h*3, 1, in );
   fclose( in );

#ifdef DJGPP
   buff = (char*) &(bmp->line[0][0]);
   for( i=0 ; i<w*h*3 ; i=i+3 )
     {
      unsigned char tmp = buff[i+2];
      buff[i+2] = buff[i];
      buff[i] = tmp;
     }
#endif

   save_bmp( f_out, bmp, NULL );

   destroy_bitmap( bmp );
   return 0;
  }

int bmp2raw( int k )
  {
   BITMAP *bmp;
   FILE *out;
   char *buff;
#ifdef DJGPP
   unsigned int i;
#endif

   unsigned int w=file[k].x, h=file[k].y;
   char f_out[256], f_in[256];
   sprintf( f_in , "%s.bmp", file[k].name );
   sprintf( f_out, "%s.raw", file[k].name );
   printf( "%s --> %s\n", f_in, f_out );

   bmp = load_bmp( f_in, NULL );
   if( bmp == NULL ) { printf( "BMP err\n" ); return 1; }
   buff = &(bmp->line[0][0]);

   out = fopen( f_out, "wb" );

#ifdef DJGPP
   for( i=0 ; i<w*h*3 ; i=i+3 )
     {
      unsigned char tmp = buff[i+2];
      buff[i+2] = buff[i];
      buff[i] = tmp;
     }
#endif

   fwrite( buff, w*h*3, 1, out );
   fclose( out );

   destroy_bitmap( bmp );
   return 0;
  }
